--[[
Copyright (C) 2016  Neemys

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

See <LICENSE.txt> for a copy of this license, or see <http://www.gnu.org/licenses/>
]]

if not buildingplatform then buildingplatform = {} end
if not buildingplatform.config then buildingplatform.config = {} end


--[[
Choose which platform world generator you want. You can see screenshot of the differents generators in the forum thread for this mod.
- default : Default generation using the ingame world generation. Platform placement are seed and config dependant. Size and frequency can be changed.
- concentric-circle : Big platform at spawn then the rest in concentric circle of platforms with speed platform going in the cardinals and intercadinals directions. Not seed or config dependant.
]]

buildingplatform.config.platformGenerator = "default"

-- In case concentric-circle generation in choosen, does the player should suffer from the 35% speed reduction
buildingplatform.config.speedPenalty = true
-- In case concentric-circle generation in choosen, does tiles with a speed bonus greater than the ground gain a 45% in speed bonus. Even if speed penalty is also true, the overall speed on non ground tile will still be faster than vanilla.
buildingplatform.config.tilesSpeedBonus = true
-- In case concentric-circle generation in choosen, does speed platform gain a 150% bonus in movement speed ? If set to false speed platform will still spawn and act as a concrete floor in term of movement speed.
buildingplatform.config.speedPlatformSpeedBonus = true

--[[
Control if building platform are craftable. 

- true : A recipe for building platform will be added. You still have pre-generated platform.
- false : You will have to use only pre-generated building platofrm

note : recipe will be here from the start.
]]

buildingplatform.config.craftable = false

--[[
Set the recipe for the building platform.
Only needed if you set building platform craftable.

normal : recipe using a bit of stone, stone-brick and water.
normal-expensive : Same recipe as 'normal' but ingredient requirement have been multiply by 10.
electronic : recipe that need some advanced circuit but less stone and lubricant in place of water. So in the end, you use oil, copper and iron with stone to have platform.
electronic-expensive : Same recipe as 'electronic' but ingredient requirement have been multiply by 10.
cheap : a very cheap recipe that make you wonder why using this mod in the first place.

]]

buildingplatform.config.recipe = "normal"

--[[
If set to true, solar panel, boiler, accumulator and steam engine will be placeable outside platform.
]]

buildingplatform.config.unrestrictPower = false
--[[
If set to true, boiler will be placeable outside platform.
]]

buildingplatform.config.unrestrictBoiler = false

--[[
If set to true, combinator will be placeable outside platform.
]]

buildingplatform.config.unrestrictCombinator = true

--[[
If set to true, roboport will be placeable outside platform.
]]

buildingplatform.config.unrestrictRoboport = true

--[[
If set to true, logistic chests will be placeable outside platform.
]]

buildingplatform.config.unrestrictLogistic = true

--[[
If set to true, storage tank will be placeable outside platform.
]]

buildingplatform.config.unrestrictStorageTank = false

--[[
If set to true, radar will be placeable outside platform.
]]

buildingplatform.config.unrestrictRadar = false

--[[
If set to true, substation will be placeable outside platform.
]]

buildingplatform.config.unrestrictSubstation = false

--[[
If set to true, furnaces will be placeable outside platform.
]]

buildingplatform.config.unrestrictFurnace = false

--[[
If set to true, assembling machines will be placeable outside platform.
]]

buildingplatform.config.unrestrictAssemblingMachine = false

--[[
If set to true, Labs will be placeable outside platform.
]]

buildingplatform.config.unrestrictLab = false

--[[
If set to true, beacon will be placeable outside platform.
]]

buildingplatform.config.unrestrictBeacon = false

--[[
If set to true, Rocket Silo will be placeable outside platform.
]]

buildingplatform.config.unrestrictRocketSilo = false

--[[
List of blocking by mod, set to true to unblock building of this mod, false if you want them blocked
]]

buildingplatform.config.unrestrictMod = {factorissimo=false,flowControl=true,alertCombinator=true,circuitNetworkSwitch=true,reactors=true} --reactor un unblocked because of a bug, see the forum thread for more information

--[[
If set to true, new building platform texture will be replaced by the old white concrete.
]]

buildingplatform.config.oldTexture = false

--[[
If set to true, no tile will be placeable on platforms.
]]

buildingplatform.config.blockTileOnPlatform = true

--[[
If set to true, this mod own platform will not be initialized. The tile will not even be created. Only useful if you make your own platforms using this mod's functions.
]]

buildingplatform.config.disableOwnPlatform = false

